<template>
  <div>
    <SJsonPreview
      class="overflow-y-hidden transition-[max-height] duration-300"
      :class="{
        'max-h-none': isExtended,
        'max-h-[250px]': !isExtended,
      }"
      :content="content"
    />

    <div class="flex justify-end rounded-b-sm border border-t-0 p-1">
      <SButton
        @click="isExtended = !isExtended"
        variant="ghost"
        icon="corner-arrow"
        :icon-class="isExtended ? '' : 'rotate-180 transition-transform duration-150'"
        >{{ isExtended ? 'Show less' : 'Show more' }}</SButton
      >
    </div>
  </div>
</template>

<script setup lang="ts">
import hljs from 'highlight.js';
import json from 'highlight.js/lib/languages/json';
import 'highlight.js/styles/color-brewer.css';
import SJsonPreview from './SJsonPreview.vue';

import SButton from './SButton.vue';

hljs.registerLanguage('json', json);

import { ref } from 'vue';

const isExtended = ref(false);

defineProps({
  content: {
    type: String,
    default: '',
  },
});
</script>
